/* 

Copyright 2003-2008 MicroNova (R)
All rights reserved.

Redistribution and use in source and binary forms, with or
without modification, are permitted provided that the following
conditions are met:

    * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

    * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.

    * Neither the name of MicroNova nor the names of its contributors
    may be used to endorse or promote products derived from this
    software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

*/

package com.micronova.jsp.tag;

import com.micronova.util.ServletUtil;

/** dispatching function call. */

public class CallTag extends MapTag
{
    protected String _path;
    protected String _contextPath;
    protected Boolean _doesForward;

    public final static String BODYPROPERTY = "parameter";
    public final static String RETURNPROPERTY = "_return";
    public final static String VALUEPROPERTY = "value";

    protected void init()
    {
        super.init();

        _path = null;
        _contextPath = null;
        _bodyProperty = BODYPROPERTY;
        _doesForward = Boolean.FALSE;
    }

    protected Object processValue(Object tagValue) throws Exception
    {
        super.processValue(tagValue);

        return ServletUtil.call(pageContext, _path, _contextPath, _map, _doesForward.booleanValue());
    }

    public void setPath(Object expression) throws Exception
    {
        _path = (String)evaluateAttribute("path", expression, String.class, _path);
    }

    public void setContextPath(Object expression) throws Exception
    {
        _contextPath = (String)evaluateAttribute("contextPath", expression, String.class, _contextPath);
    }

    public void setBody(Object expression) throws Exception
    {
        _body = evaluateAttribute("body", expression, Object.class, _body);
    }

    public void setDoesForward(Object expression) throws Exception
    {
        _doesForward = (Boolean)evaluateAttribute("doesForward", expression, Boolean.class, _doesForward);
    }
}
