/* 

Copyright 2003-2008 MicroNova (R)
All rights reserved.

Redistribution and use in source and binary forms, with or
without modification, are permitted provided that the following
conditions are met:

    * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

    * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.

    * Neither the name of MicroNova nor the names of its contributors
    may be used to endorse or promote products derived from this
    software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

*/

package com.micronova.jsp.tag;

import com.micronova.util.NestedMap;
import com.micronova.util.XMLUtil;
import com.micronova.util.cc.html.Parser;
import javax.servlet.ServletContext;

public class ParseHtmlTag extends YuzuTag
{
    protected NestedMap _controlMap;
    protected String _prefix;
    protected String _rootName;
    protected String _strategy;
    protected String _exclude;
    protected String _include;

    protected void init()
    {
        super.init();

        _prefix = null;
        _rootName = null;
        _strategy = null;
        _exclude = null;
        _include = null;
    }

    protected void prepare() throws Exception
    {
        super.prepare();

        _controlMap = new NestedMap();

        _controlMap.put("prefix", _prefix);
        _controlMap.put("rootName", _rootName);
        _controlMap.put("strategy", _strategy);
        _controlMap.put("exclude", _exclude);
        _controlMap.put("include", _include);
    }

    public void setPrefix(Object expression) throws Exception
    {
        _prefix = (String)evaluateAttribute("prefix", expression, String.class, _prefix);
    }

    public void setRootName(Object expression) throws Exception
    {
        _rootName = (String)evaluateAttribute("rootName", expression, String.class, _rootName);
    }

    public void setStrategy(Object expression) throws Exception
    {
        _strategy = (String)evaluateAttribute("strategy", expression, String.class, _strategy);
    }

    public void setExclude(Object expression) throws Exception
    {
        _exclude = (String)evaluateAttribute("exclude", expression, String.class, _exclude);
    }

    public void setInclude(Object expression) throws Exception
    {
        _include = (String)evaluateAttribute("include", expression, String.class, _include);
    }

    protected Object processValue(Object tagValue) throws Exception
    {
        if (tagValue != null)
        {
            try
            {
                return XMLUtil.parseHtml(tagValue, _controlMap);
            }
            catch (Exception e)
            {
                ServletContext context = pageContext.getServletContext();

                context.log("HtmlTag:BEGIN ========");
                context.log(tagValue.toString());
                context.log("HtmlTag:END   ========");
                
                throw e;
            }
        }
        else
        {
            return null;
        }
    }
}
