/* Generated By:JavaCC: Do not edit this line. Parser.java */
package com.micronova.util.cc.json;

import com.micronova.util.NestedMap;
import com.micronova.util.SparseList;
import com.micronova.util.StringUtil;
import com.micronova.util.TypeUtil;
import java.io.StringReader;
import java.util.List;
import java.util.Map;

public class Parser implements ParserConstants {
    protected boolean _allowUnquoted = true;
    protected boolean _allowExpression = true;

    public void setAllowUnquoted(boolean allowUnquoted)
    {
        this._allowUnquoted = allowUnquoted;
    }

    public static Object parse(String string, boolean allowUnquoted) throws Exception
    {
        Parser parser = new Parser(new StringReader(string));
        parser.setAllowUnquoted(allowUnquoted);
        return parser.parse();
    }

    public static Object parse(String string) throws Exception
    {
        return parse(string, true);
    }

    public static void main(String arg[])
    {
        try
        {
            System.out.println("parsed:" + parse(arg[0]));
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }

  final public String key() throws ParseException {
  String value = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DOUBLEQUOTED:
      jj_consume_token(DOUBLEQUOTED);
                    value = StringUtil.decodeBackslash(token.image); value = value.substring(1, value.length() - 1);
      break;
    case SINGLEQUOTED:
      jj_consume_token(SINGLEQUOTED);
                    value = StringUtil.decodeBackslash(token.image); value = value.substring(1, value.length() - 1);
      break;
    case EXPRESSION:
      jj_consume_token(EXPRESSION);
        if (!this._allowExpression)
        {
            {if (true) throw new RuntimeException("expression string is not allowed:" + token.image);}
        }
        value = StringUtil.decodeBackslash(token.image);
      break;
    case UNQUOTED:
      jj_consume_token(UNQUOTED);
        if (!this._allowUnquoted)
        {
            {if (true) throw new RuntimeException("unquoted string is not allowed:" + token.image);}
        }
        value = StringUtil.decodeBackslash(token.image);
      break;
    default:
      jj_consume_token(-1);
      throw new ParseException();
    }
    {if (true) return value;}
    throw new Error("Missing return statement in function");
  }

  final public Object value() throws ParseException {
  Object value = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TRUE:
      jj_consume_token(TRUE);
            value = new Boolean(true);
      break;
    case FALSE:
      jj_consume_token(FALSE);
             value = new Boolean(false);
      break;
    case NULL:
      jj_consume_token(NULL);
            value = null;
      break;
    case LONG:
      jj_consume_token(LONG);
            value = TypeUtil.isLong(token.image);
      break;
    case DOUBLE:
    case EDOUBLE:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DOUBLE:
        jj_consume_token(DOUBLE);
        break;
      case EDOUBLE:
        jj_consume_token(EDOUBLE);
        break;
      default:
        jj_consume_token(-1);
        throw new ParseException();
      }
                          value = TypeUtil.isDouble(token.image);
      break;
    case DOUBLEQUOTED:
    case SINGLEQUOTED:
    case EXPRESSION:
    case UNQUOTED:
      value = key();
      break;
    default:
      jj_consume_token(-1);
      throw new ParseException();
    }
    {if (true) return value;}
    throw new Error("Missing return statement in function");
  }

  final public Map map() throws ParseException {
  Map map = null;
  String key = null;
  Object value = null;
    jj_consume_token(OPENCURLYBRACKET);
                      map = new NestedMap();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DOUBLEQUOTED:
    case SINGLEQUOTED:
    case EXPRESSION:
    case UNQUOTED:
      key = key();

      jj_consume_token(COLON);
      value = parse();
                     map.put(key, value);
      break;
    default:
      ;
    }
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        break label_1;
      }
      jj_consume_token(COMMA);
      key = key();

      jj_consume_token(COLON);
      value = parse();
                     map.put(key, value);
    }
    jj_consume_token(CLOSECURLYBRACKET);
    {if (true) return map;}
    throw new Error("Missing return statement in function");
  }

  final public List list() throws ParseException {
  List list = null;
  Object value = null;
    jj_consume_token(OPENBRACKET);
                 list = new SparseList();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPENCURLYBRACKET:
    case OPENBRACKET:
    case DOUBLEQUOTED:
    case SINGLEQUOTED:
    case TRUE:
    case FALSE:
    case NULL:
    case LONG:
    case DOUBLE:
    case EDOUBLE:
    case EXPRESSION:
    case UNQUOTED:
      value = parse();
                     list.add(value);
      break;
    default:
      ;
    }
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        break label_2;
      }
      jj_consume_token(COMMA);
      value = parse();
                     list.add(value);
    }
    jj_consume_token(CLOSEBRACKET);
                  {if (true) return list;}
    throw new Error("Missing return statement in function");
  }

  final public Object parse() throws ParseException {
  Object value = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DOUBLEQUOTED:
    case SINGLEQUOTED:
    case TRUE:
    case FALSE:
    case NULL:
    case LONG:
    case DOUBLE:
    case EDOUBLE:
    case EXPRESSION:
    case UNQUOTED:
      value = value();
                   {if (true) return value;}
      break;
    case OPENCURLYBRACKET:
      value = map();
                 {if (true) return value;}
      break;
    case OPENBRACKET:
      value = list();
                  {if (true) return value;}
      break;
    default:
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  public ParserTokenManager token_source;
  SimpleCharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;

  public Parser(java.io.InputStream stream) {
     this(stream, null);
  }
  public Parser(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new ParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
  }

  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
  }

  public Parser(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new ParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
  }

  public Parser(ParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
  }

  public void ReInit(ParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      return token;
    }
    token = oldToken;
    throw generateParseException();
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    return token;
  }

  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  public ParseException generateParseException() {
    Token errortok = token.next;
    int line = errortok.beginLine, column = errortok.beginColumn;
    String mess = (errortok.kind == 0) ? tokenImage[0] : errortok.image;
    return new ParseException("Parse error at line " + line + ", column " + column + ".  Encountered: " + mess);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

}
